alias dict {
  $iif($dialog(dict),dialog -v dict,dialog -m dict dict)
  if ($1-) {
    did -a dict 2 $1-
    did -r dict 3
    sockclose dictionary
    set %dict.word " $+ $did(dict,2) $+ "
    set %dict.oper all
    sockopen dictionary test.dict.org 2628
  }
}

dialog dict {
  title "Dictionary"
  icon $icons(dictionary.ico)
  size -1 -1 160 120
  option dbu
  text "Word/Phrase to look up:", 1, 2 3 59 8
  edit "", 2, 2 11 154 10
  edit "", 3, 2 36 155 82, readonly multi autovs autohs
  button "Look Up", 4, 119 22 37 12, flat
}

on *:dialog:dict:sclick:4:{
  if ($did(2) == $null) { did -r dict 3 | did -a dict 3 Please specify a word or phrase to look up at dict.org. | halt }
  did -r dict 3
  sockclose dictionary
  set %dict.word " $+ $did(2) $+ "
  set %dict.oper all
  sockopen dictionary www.dict.org 2628
}

alias -l dict.stop { .sockclose dictionary | unset %dict.oper | unset %dict.word | unset %dict.data }

alias -l dict.clearline { unset %dict.blank }
alias -l dict.blankline { if (%dict.blank == $null) { add.dict $chr(160) | set %dict.blank 1 } }

on *:sockread:dictionary: {
  sockread %dict.data
  if ($left(%dict.data,3) == 220) {
    if (%dict.oper == all) { .sockwrite $sockname $crlf $+ DEFINE * %dict.word $+ $crlf }
    if (%dict.oper == one) { .sockwrite $sockname $crlf $+ DEFINE ! %dict.word $+ $crlf }
    halt
  }
  if ($left(%dict.data,3) == 500) { halt }
  if ($left(%dict.data,3) == 150) { did -a dict 3 Results: $gettok(%dict.data,2,32) matches found. | dict.blankline | halt }
  if ($left(%dict.data,3) == 501) { did -a dict 3 Error: Syntax error. | dict.clearline | dict.stop | halt }
  if ($left(%dict.data,3) == 250) { dict.stop | dict.clearline | halt }
  if ($left(%dict.data,3) == 151) { add.dict From: $gettok(%dict.data,4,34) | dict.clearline | halt }
  if ($left(%dict.data,3) == 552) { did -a dict 3 Error: No matches. | dict.clearline | dict.stop | halt }

  ; trim leading and trailing spaces but add a pseudospace to nonblank lines
  %dict.data = $trimspaces( 160 , %dict.data )
  if ((%dict.data == .) || (%dict.data == $null) || ($remove(%dict.data, $chr(9)) == $null)) { dict.blankline | halt }

  add.dict %dict.data
  dict.clearline
}


alias trimspaces {
  ; remove leading and trailing spaces
  var %indentchar = $1
  var %retv = $2-
  var %len
  var %leftspace = 0

  ; remove leading spaces
  while ( ($left(%retv,1) == $chr(32) ) || ( $left(%retv,1) == $chr(9) ) ) {
    %len = $len(%retv)
    %len = %len - 1
    %retv = $right(%retv, %len)
    %leftspace = %leftspace + 1
  }

  ; remove trailing spaces
  while ( ($right(%retv,1) == $chr(32) ) || ( $right(%retv,1) == $chr(9) ) ) {
    %len = $len(%retv)
    %len = %len - 1
    %retv = $left(%retv, %len)
  }

  ; add the indent character if desired
  if (%indentchar != 0) {
    if ( ($len(%retv) >= 1) && (%leftspace > 0) ) { %retv = $chr(%indentchar) $+ %retv }
  }

  return %retv
}

alias -l add.dict { did -a dict 3 $crlf $+ $1- }
